Subject: Re: Very low latency TCP for clusters

From: Rick Jones <[email-masked]>
Date: Tue, 20 Jul 2010 10:24:55 -0700

Eric Dumazet wrote:
> Le lundi 19 juillet 2010 à 16:37 -0700, Tom Herbert a écrit :
> 
>>That's pretty pokey ;-) I see numbers around 25 usecs between to
>>machines, this is with TCP_NBRR.  With TCP_RR it's more like 35 usecs,
>>so eliminating the scheduler is already a big reduction.  That leaves
>>18 usecs in device time, interrupt processing, network, and cache
>>misses; 7 usecs in TCP processing, user space.  While 5 usecs is an
>>aggressive goal, I am not ready to concede that there's an
>>architectural limit in either NICs, TCP, or sockets that can't be
>>overcome.
> 
> Last time I tried TCP_NBRR, it was not working (not even compiled in), I
> guess I should submit a bug report to Rick ;)

Indeed!-)  Actually, my first thought upon reading what Tom wrote was "Wow, I'm 
amazed it still works" :)  That code probably hasn't been visited much since the 
heydays of T/TCP (transactional).

Getting it compiled-in probably required a hand-editing of the config.h file 
after the ./configure.  Patches to add a --enable-nbrr would be graciously accepted.

happy benchmarking,

rick jones